#include "stdafx.h"

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

// Example
void __stdcall mycalc(IEasyLanguageObject* pEL, LPCSTR varName, double newprice)
{
	IEasyLanguageVariable *pVar = pEL->Variables[ varName ] ;
	if ( pVar )
		pVar->AsDouble[1] = newprice;
}

double __stdcall GetPrevValue(IEasyLanguageObject* pEL, LPCSTR varName)
{
	double res = 0;
	IEasyLanguageVariable *pVar = pEL->Variables[ varName ] ;
	if ( pVar )
		res = pVar->AsDouble[1];
	return res;
}

int __stdcall TestObject(IEasyLanguageObject* pEL)
{
	return 0;
}

int __stdcall Terminate(IEasyLanguageObject* pEL)
{
	std::fstream ofstr("C:\\Terminate.txt", std::ios::out | std::ios::app);
	ofstr<<"Terminate"<<std::endl;

	return 0;
}

/*
//           PL   env
BOOL __stdcall _GetQMIETestDir(IEasyLanguageObject* pELObj, LPCSTR envName)
{
	BOOL bResult = FALSE;

	std::string szPlEnvName("env");
	szPlEnvName += envName;

	_variant_t varName(szPlEnvName.c_str());
	IEasyLanguageVariable* pELVar = pELObj->Variables[varName];

	if (pELVar)
	{
		_bstr_t bsEnvName = envName;
		DWORD EnvSize = ::GetEnvironmentVariableW((LPCWSTR)bsEnvName, NULL, 0);	
		if(EnvSize)														
		{																
			EnvSize++;
			std::vector<wchar_t> string_buf((EnvSize), 0);
			LPWSTR wsPath = &string_buf.front();

			if(::GetEnvironmentVariableW((LPCWSTR)bsEnvName, wsPath, EnvSize))	
			{
				bResult = TRUE;
				pELVar->put_AsString(0, wsPath);
			}														
		}
	}
    return bResult;
}
*/